"""
        Python bindings for SRF logging
        -------------------------------
        .. currentmodule:: logging
        .. autosummary::
           :toctree: _generate
    """
from __future__ import annotations
import srf.core.logging
import typing

__all__ = [
    "get_level",
    "init_logging",
    "is_initialized",
    "log",
    "set_level"
]


def get_level() -> int:
    """
    Gets the log level for Srf's logger.
    """
def init_logging(logname: str, py_level: int = 20) -> bool:
    """
    Initializes Srf's logger, The return value inidicates if the logger was initialized, which will be `True` on the first call, and `False` for all subsequant calls.
    """
def is_initialized() -> bool:
    """
    Checks if Srf's logger has been initialized.
    """
def log(msg: str, py_level: int = 20, filename: str = '', line: int = 0) -> None:
    """
    Logs a message to Srf's logger.
    """
def set_level(py_level: int) -> None:
    """
    Sets the log level for Srf's logger.
    """
__version__ = 'dev'
